/**************************************************************************
**  (c) Copyright 2002, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : doodle2.cpp
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.2 $
**
**  DESCRIPTION      :  Doodle is an exmaple application to demonstrate
**                      the functions in AXE as a tutorial.
**                      The second phase shows how to draw graphics in a
**                      window and the event handling mechanism.
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Mar 01, 2002
**************************************************************************/

/*****************************
   $Log: doodle2.cpp,v $
   Revision 1.2  2002/11/04 07:44:45  arjen
   Use proper namespace for iostream classes
   Use local header files and not the installed ones.

   Revision 1.1  2002/07/25 08:01:18  arjen
   First checkin, AXE release 0.2

*****************************/

static const char *RCSID = "$Id: doodle2.cpp,v 1.2 2002/11/04 07:44:45 arjen Exp $";

#include "xappl.h"

class doodle_view : public window
{
public:

   doodle_view(window *parent) : window (*parent, 10, 30, 300, 220)
   {
      SelectInput(ExposureMask, 1);
      Background(color("lightyellow"));
   }

   virtual int EV_Expose(XExposeEvent);
};

class doodle: public xapplication
{
   managed_window *main_frame;
   doodle_view    *draw_frame;

   virtual void SetupResources(void);
};

doodle DoodleApp;

void doodle::SetupResources()
{
   main_frame = new managed_window("Doodling with AXE");
   main_frame->Map();

   draw_frame = new doodle_view(main_frame);
   draw_frame->Map();
}

int doodle_view::EV_Expose(XExposeEvent ev)
{
   gc    graphic("black");

   DrawRectangle(graphic, 50, 70, 200, 100);

   return 1;
}
