<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" indent="yes" encoding="iso-8859-1"/>

<xsl:include href="file:////usr/local/xslt/html.xsl"/>

<xsl:template match='class'>
<html>
<head>
   <title>Class Specification of <xsl:value-of select='@name'/></title>
</head>
<body>
   <h1>Class Specification of <xsl:value-of select='@name'/></h1>
   <hr/>
   <h2>NAME</h2>
   <p><xsl:value-of select='@name'/> - <xsl:value-of select='title'/></p>

   <xsl:apply-templates/>
</body>
</html>
</xsl:template>

<xsl:template match='title'>
</xsl:template>

<xsl:template match='synopsis'>
   <h2>SYNOPSIS</h2>
   <xsl:apply-templates/>
</xsl:template>

<xsl:template match='class/description'>
   <h2>DESCRIPTION</h2>
   <xsl:apply-templates/>
</xsl:template>

<xsl:template match='function/description'>
   <h4>DESCRIPTION</h4>
   <xsl:apply-templates/>
</xsl:template>

<xsl:template match='methods'>
   <table border='1'>
   <tr><th colspan='2'>METHODS</th></tr>
   <xsl:for-each select='function'>
   <tr>
      <td border='1'><xsl:value-of select='@name'/></td>
      <td border='1'><xsl:value-of select='title'/></td>
   </tr>
   </xsl:for-each>
   </table>
   <xsl:apply-templates/>
</xsl:template>

<xsl:template match='function'>
   <h3><xsl:value-of select='@name'/> - <xsl:value-of select='title'/></h3>
   <xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>




