/**************************************************************************
**  (c) Copyright 1999, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : amount.cpp
**      SYSTEM NAME    : Andromeda X-Windows Encapsulation
**      VERSION NUMBER : $Revision: 1.2 $
**
**  DESCRIPTION      :  Financial classes : amount
**
**  EXPORTED OBJECTS : class amount
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Aug 26, 1999
**      LAST UPDATE     : Aug 26, 1999
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: amount.cpp,v $
   Revision 1.2  2002/11/04 07:24:31  arjen
   Use proper namespace for iostream classes

   Revision 1.1  2002/07/25 08:01:26  arjen
   First checkin, AXE release 0.2

*****************************/

static const char RCSID[] = "$Id: amount.cpp,v 1.2 2002/11/04 07:24:31 arjen Exp $";

#include "money.h"

std::istream &operator>>(std::istream &s, amount &a)
{
   long   hundreds;
   char   c;

   s >> hundreds >> c >> a.value;
   a.value += hundreds * 100;

   return s;
}

std::ostream &operator<<(std::ostream &s, amount a)
{
   if (a == 0)
   {
      s << "           ";
   }
   else
   {
      s.width(8);
      s.fill(' ');
      s << a / 100;
      s << '.';
      s.width(2);
      s.fill('0');
      s << a % 100;
      //s << form("%8d.%02d",a / 100, a % 100);
   }

   return s;
}

amount::amount(String s)
{
   int  dp;   // The position of the decimal point

   dp = s.index('.');
   if (dp == -1)
   {
      dp = s.index(',');
   }
   if (dp != -1)
   {
      String  whole;

      whole = s(0, dp);
      value = whole;
      value *= 100;
      s <<= dp + 1;
      value += (unsigned long)s;
   }
   else
   {
      //  No decimal point; integer value

      value = s;
      value *= 100;
   }
}

amount::operator String()
{
   String s;

   s = String(value / 100) + "." + String(value % 100);

   return s;
}

String amount::make_string(void)
{
   String s;
   String decimals;

   s = String(value / 100) + ".";
   decimals = String(value % 100);
   if (~decimals == 1)
   {
      decimals = "0" + decimals;
   }

   s += decimals;

   return s;
}


