
/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : button.h
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      :  Definition of button classes
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Mar 07, 1998
**      LAST UPDATE     : Mar 13, 1998
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: button.h,v $
   Revision 1.1  2002/07/25 08:01:26  arjen
   First checkin, AXE release 0.2

*****************************/

/* static const char *RCSID = "$Id: button.h,v 1.1 2002/07/25 08:01:26 arjen Exp $"; */

#include "frame.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : button
//  BASECLASS      : frame
//  MEMBERS        :
//  OPERATORS      :
//  METHODS        :
//
//  DESCRIPTION    :
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  :
///////////////////////////////////////////////////////////////////////////
*/

class button : public frame
{

public:

   button(window &par, int x, int y,char *label) : frame(par, x, y, label)
   {
      SelectInput(ButtonReleaseMask|ButtonPressMask, 1);
   }

   virtual int EV_ButtonPress(XButtonEvent ev)
   {
      Strength(-Strength());
      return 1;
   }

   virtual int EV_ButtonRelease(XButtonEvent ev)
   {
      Strength(-Strength());
      return 1;
   }
};

class touch_button : public button
{

public:

   touch_button(window &par, int x, int y, char *label)
          : button(par, x, y, label)
   {
   }


   virtual int EV_ButtonPress(XButtonEvent ev);

   virtual void click(void);
};


class toggle_button : public touch_button
{
   enum { State_Off, State_On }  state;

public:

   toggle_button(window &par, int x, int y, char *label)
          : touch_button(par, x, y, label)
   {
      state = State_Off;
   }

   virtual void click(void);

   virtual void redraw(void);
};

class command_button : public button
{
   int command_code;

public:

   command_button(window &par, int x, int y, char *label, int cc = 0)
		   : button(par, x, y, label)
   {
      command_code = cc;
   }

   virtual int EV_ButtonPress(XButtonEvent ev)
   {
      Strength(-Strength());
      return 1;
   }

   virtual int EV_ButtonRelease(XButtonEvent ev)
   {
      Strength(-Strength());

      return XApp->SendCommand(command_code);
   }
};

