/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : color.h
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      : Definition of color class 
**
**  EXPORTED OBJECTS : class color
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Feb 24, 1998
**      LAST UPDATE     : Feb 24, 1998
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: color.h,v $
   Revision 1.1  2002/07/25 08:01:26  arjen
   First checkin, AXE release 0.2

*****************************/

/* static const char *RCSID = "$Id: color.h,v 1.1 2002/07/25 08:01:26 arjen Exp $"; */

#include <X11/Xlib.h>
#include "display.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : color
//  BASECLASS      :
//  MEMBERS        : XColor xcol;
//  OPERATORS      :
//  METHODS        :
//
//  DESCRIPTION    :
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Feb 24, 1998
///////////////////////////////////////////////////////////////////////////
*/

class color
{
   XColor xcol;

public:

   color()
   {
      xcol.pixel = 0;
   }

   color(unsigned red, unsigned green, unsigned blue)
   {
      xcol.red    = red;
      xcol.green  = green;
      xcol.blue   = blue;
      xcol.flags  = DoRed | DoGreen | DoBlue;

      XAllocColor(stddpy, stddpy.ColMap(), &xcol);
   }

   color(char *colorname)
   {
       XColor  exact;

       XAllocNamedColor(stddpy, stddpy.ColMap(), colorname, &xcol, &exact);
   }

   void Alloc(unsigned red, unsigned green, unsigned blue)
   {
      xcol.red    = red;
      xcol.green  = green;
      xcol.blue   = blue;
      xcol.flags  = DoRed | DoGreen | DoBlue;

      XAllocColor(stddpy, stddpy.ColMap(), &xcol);
   }

   void Alloc(char *colorname)
   {
       XColor  exact;

       XAllocNamedColor(stddpy, stddpy.ColMap(), colorname, &xcol, &exact);
   }

   operator unsigned long() const
   {
      return xcol.pixel;
   }

};

