/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : cursor.h
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      : Definition of cursor class
**
**  EXPORTED OBJECTS : class cursor
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Feb 25, 1998
**      LAST UPDATE     : Feb 25, 1998
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: cursor.h,v $
   Revision 1.1  2002/07/25 08:01:26  arjen
   First checkin, AXE release 0.2

*****************************/

/* static const char *RCSID = "$Id: cursor.h,v 1.1 2002/07/25 08:01:26 arjen Exp $"; */

#include <X11/Xlib.h>
#include <X11/cursorfont.h>
#include "display.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : cursor
//  BASECLASS      :
//  MEMBERS        : Cursor curs
//  OPERATORS      :
//  METHODS        :
//
//  DESCRIPTION    :
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Feb 25, 1998
///////////////////////////////////////////////////////////////////////////
*/

class cursor
{
   Cursor curs;

public:

   cursor()
   {
      curs = 0;
   }

   cursor(unsigned int shape)
   {
      curs = XCreateFontCursor(stddpy, shape);
   }

   ~cursor()
   {
      XFreeCursor(stddpy, curs);
   }

   operator Cursor()
   {
      return curs;
   }
};

