
#include "button.h"
#include "edit.h"
#include "table.h"
#include "pixmap.h"

#define OPEN_DLG_OK  100
#define OPEN_DLG_CANCEL 101

#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>

struct file_entry
{
   String        name;
   struct stat   st;
};

bool operator < (const file_entry &fe1, const file_entry &fe2);

class directory_view : public table_view
{
   String                   cwd;
   std::vector<file_entry>  d_list;

   pixmap         dir;
   pixmap         reg;

   int   scan();

public:

   directory_view(window &parent);

   void redraw();
   String changedir(String dir);

   bool selected_a_dir()
   {
      return S_ISDIR(d_list[selected()].st.st_mode) != 0;
   }
};


class file_dialog : public managed_window
{
   command_button *OK;
   command_button *Cancel;
   edit           *diredit;
   edit           *fileedit;
   directory_view *directory_list;
   int            OK_command;

public:

   file_dialog(int cmd);

   String PathName()
   {
      return *diredit + "/" + *fileedit;
   }

   virtual int DoCommand(int code);

   virtual void ChildMessage(win_message &msg);
};

