/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : font.cpp
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.2 $
**
**  DESCRIPTION      :  Implementation of font class
**
**  EXPORTED OBJECTS : font::TextWidth()
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Feb 13, 1998
**      LAST UPDATE     : Feb 13, 1998
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: font.cpp,v $
   Revision 1.2  2002/11/04 07:24:31  arjen
   Use proper namespace for iostream classes

   Revision 1.1  2002/07/25 08:01:26  arjen
   First checkin, AXE release 0.2

*****************************/

static const char *RCSID = "$Id: font.cpp,v 1.2 2002/11/04 07:24:31 arjen Exp $";

#include <string.h>
#include "font.h"

int font::TextWidth(char *string, int length)
{
   if (length == 0)
   {
      length = strlen(string);
   }

   return XTextWidth(fs, string, length);
}

int font::TextWidth(const String & string)
{
   return XTextWidth(fs, string, ~string);
}
