/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : font.h
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.2 $
**
**  DESCRIPTION      : Definition of font class 
**
**  EXPORTED OBJECTS : class font
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Feb 13, 1998
**      LAST UPDATE     : Jan 22, 2002
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: font.h,v $
   Revision 1.2  2002/11/04 07:24:31  arjen
   Use proper namespace for iostream classes

   Revision 1.1  2002/07/25 08:01:26  arjen
   First checkin, AXE release 0.2

*****************************/

/* static const char *RCSID = "$Id: font.h,v 1.2 2002/11/04 07:24:31 arjen Exp $"; */

#include <iostream>
#include <X11/Xlib.h>
#include "display.h"
#include "String.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : font
//  BASECLASS      :
//  MEMBERS        : XFontStruct *fs
//  OPERATORS      :
//  METHODS        :
//
//  DESCRIPTION    :
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Jan 22, 2002
///////////////////////////////////////////////////////////////////////////
*/

class font
{
   XFontStruct *fs;

public:

   font()
   {
      fs = 0;
   }

   font(char *name)
   {
      fs = XLoadQueryFont(stddpy.Dpy(), name);
      if (fs == NULL)
      {
         std::cerr << "Warnig: can not open font " << name << "\n";
      }
   }

   ~font()
   {
      if (fs)
         XFreeFont(stddpy.Dpy(), fs);
   }

   operator bool(void)
   {
      return fs != 0;
   }

   void Load(char *name)
   {
      if (fs)
         XFreeFont(stddpy.Dpy(), fs);
      fs = XLoadQueryFont(stddpy.Dpy(), name);
      if (fs == NULL)
      {
         std::cerr << "Warnig: can not open font " << name << "\n";
      }
   }

   operator XID ()
   {
      return fs ? fs->fid : 0;
   }

   int TextWidth(char *string, int length = 0);
   int TextWidth(const String & string);

   int ascent(void)
   {
      return fs ? fs->ascent : 0;
   }

   int descent(void)
   {
      return fs ? fs->descent : 0;
   }
};

