
/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : geometry.cpp
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      :  Implementation of geometry classes
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Apr 04, 1998
**      LAST UPDATE     : Apr 04, 1998
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: geometry.cpp,v $
   Revision 1.1  2002/07/25 08:01:27  arjen
   First checkin, AXE release 0.2

*****************************/

static const char *RCSID = "$Id: geometry.cpp,v 1.1 2002/07/25 08:01:27 arjen Exp $";

#include "geometry.h"

rectangle::rectangle(point p1, point p2)
{
   if (p1.x < p2.x)
   {
      x = p1.x;
      w = p2.x - p1.x;
   }
   else
   {
      x = p2.x;
      w = p1.x - p2.x;
   }

   if (p1.y < p2.y)
   {
      y = p1.y;
      h = p2.y - p1.y;
   }
   else
   {
      y = p2.y;
      h = p1.y - p2.y;
   }
}

bool rectangle::encloses(point p)
{
   return p.x > x && p.x < x + w && p.y > y && p.y < y + h;
}

bool rectangle::encloses(rectangle r)
{
   return encloses(r.Origin()) && encloses(r.Origin() + r.Size());
}

point operator + (point p1, point p2)
{
   p1.x += p2.x;
   p1.y += p2.y;

   return p1;
}

point operator + (point p, size s)
{
   p.x += s.w;
   p.y += s.h;

   return p;
}

