
/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : geometry.h
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      :  Definition of geometry classes: point, size, rect
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Mar 04, 1998
**      LAST UPDATE     : Jul 05, 2000
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: geometry.h,v $
   Revision 1.1  2002/07/25 08:01:27  arjen
   First checkin, AXE release 0.2

*****************************/

/* static const char *RCSID = "$Id: geometry.h,v 1.1 2002/07/25 08:01:27 arjen Exp $"; */

#ifndef  AXE_GEOMETRY_H
#define  AXE_GEOMETRY_H

class point
{
public:

   short   x, y;

   point()
   {
      x = 0; y = 0;
   }

   point(short _x, short _y)
   {
      x = _x;
      y = _y;
   }
};

class size
{
public:

   unsigned short w, h;

   size()
   {
      w = 0;
      h = 0;
   } 

   size(unsigned short width, unsigned short height)
   {
      w = width;
      h = height;
   }
};

class rectangle
{
   short          x, y;
   unsigned short w, h;


public:

   rectangle()
   {
      x      = 0;
      y      = 0;
      w      = 0;
      h      = 0;
   }

   rectangle(int _x, int _y, unsigned int _w, unsigned int _h)
   {
      x      = _x;
      y      = _y;
      w      = _w;
      h      = _h;
   }

   rectangle(point p, size s)
   {
      x      = p.x;
      y      = p.y;
      w      = s.w;
      h      = s.h;
   }

   //  Define a rectangle by its diagonal

   rectangle(point p1, point p2);

   point Origin()
   {
      return point(x, y);
   }

   size Size()
   {
      return size(w, h);
   }

   bool encloses(point);
   bool encloses(rectangle);
};

point operator + (point p1, point p2);
point operator + (point p, size s);

//
//   ParseGeometryString

#endif
