/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : icon.h
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      : Definition of icon class
**
**  EXPORTED OBJECTS : class icon
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Jul 13, 2000
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: icon.h,v $
   Revision 1.1  2002/07/25 08:01:27  arjen
   First checkin, AXE release 0.2

*****************************/

/* static const char *RCSID = "$Id: icon.h,v 1.1 2002/07/25 08:01:27 arjen Exp $"; */

#ifndef AXE_ICON_H
#define AXE_ICON_H

#include <X11/Xlib.h>
#include <X11/xpm.h>
#include "xwindow.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : icon
//  BASECLASS      :
//  MEMBERS        : pixmap picture;
//  OPERATORS      :
//  METHODS        :
//
//  DESCRIPTION    :  An icon is a window that contains a pixmap.
//                    It automatically redraws on Expose events.
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Jul 13, 2000
///////////////////////////////////////////////////////////////////////////
*/

class icon : public window
{
   pixmap picture;

   virtual int EV_Expose(XExposeEvent ev);

public:

   icon(window &parent, int x, int y, char *data, unsigned int w, unsigned int h) :
        window(parent, x, y, w, h)
   {
      //picture = XCreateBitmapFromData(stddpy, stddpy.Root(), data, w, h);
      SelectInput(ExposureMask, 1);
   }

   icon(window &parent, int x, int y, char *pixmap_data[]) :
                               window(parent, x, y, 4, 4, 0)
   {
      picture.create(pixmap_data);
      Resize(picture.Size());
      SelectInput(ExposureMask, 1);
   }

   icon(window &parent, int x, int y, char *filename) : window(parent, x, y, 4, 4, 0)
   {
      picture.read(filename);
      Resize(picture.Size());
      SelectInput(ExposureMask, 1);
   }

};

#endif /* AXE_ICON_H  */
