/**************************************************************************
**  (c) Copyright 1999, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : money.h
**      SYSTEM NAME    : Andromeda X-Windows Encapsulation
**      VERSION NUMBER : $Revision: 1.2 $
**
**  DESCRIPTION      :  Financial classes
**
**  EXPORTED OBJECTS : class amount
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Aug 26, 1999
**      LAST UPDATE     : Aug 26, 1999
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: money.h,v $
   Revision 1.2  2002/11/04 07:24:31  arjen
   Use proper namespace for iostream classes

   Revision 1.1  2002/07/25 08:01:27  arjen
   First checkin, AXE release 0.2

*****************************/

// static const char RCSID[] = "$Id: money.h,v 1.2 2002/11/04 07:24:31 arjen Exp $";

#ifndef MONEY_H
#define MONEY_H

#include <math.h>
#include <iostream>
#include "String.h"

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
**  NAME           : amount - Encapsulate an amount of money
**  MEMBERS        : value - The monetary value (in cents)
**  OPERATORS      : 
**                   ostream << : String to output stream.
**                   istream << : String from input stream.
**  METHODS        :
**
**  DESCRIPTION    : 
**
**  RELATIONS      : 
**  SEE ALSO       :
**  LAST MODIFIED  : Aug 26, 1999
**+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/

class amount
{
   unsigned long  value;

public:

   amount()
   {
      value = 0;
   }

   amount(unsigned long l)
   {
      value = l;
   }

   amount(String s);

   operator long()
   {
      return value;
   }

   operator String();
   String make_string(void);

   amount operator+(amount a)
   {
      amount sum;

      sum.value = value + a.value;
      return sum;
   }

   amount operator *= (double f)
   {
      double  v;

      v = rint(value * f);
      value = (unsigned long)v;

      return *this;
   }

   amount operator /= (double f)
   {
      double  v;

      v = rint(value / f);
      value = (unsigned long)v;

      return *this;
   }

   amount &operator+=(amount a)
   {
      value += a.value;

      return *this;
   }

   friend std::istream &operator>>(std::istream&, amount &);
   friend std::ostream &operator<<(std::ostream&, amount);

};

#endif  /* MONEY_H */
