/**************************************************************************
**  (c) Copyright 1998, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : pattern.h
**      SYSTEM NAME    : AXE - Andromeda X-windows Encapsulation
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      : Definition of patterning classes: stipple, tile 
**
**  EXPORTED OBJECTS : class stipple
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Feb 25, 1998
**      LAST UPDATE     : Feb 25, 1998
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: pattern.h,v $
   Revision 1.1  2002/07/25 08:01:27  arjen
   First checkin, AXE release 0.2

*****************************/

/* static const char *RCSID = "$Id: pattern.h,v 1.1 2002/07/25 08:01:27 arjen Exp $"; */

#include <X11/Xlib.h>
#include "display.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : stipple
//  BASECLASS      :
//  MEMBERS        : Pixmap pixm;
//  OPERATORS      :
//  METHODS        :
//
//  DESCRIPTION    :
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Feb 25, 1998
///////////////////////////////////////////////////////////////////////////
*/

class stipple
{
   Pixmap pixm;

public:

   stipple()
   {
      pixm = 0;
   }

   stipple(char *data, unsigned int w, unsigned int h)
   {
      pixm = XCreateBitmapFromData(stddpy, stddpy.Root(), data, w, h);
   }

   ~stipple()
   {
      XFreePixmap(stddpy, pixm);
   }

   operator Pixmap()
   {
      return pixm;
   }
};

